Index: channels/chan_zap.c
===================================================================
--- channels/chan_zap.c	(revision 48471)
+++ channels/chan_zap.c	(working copy)
@@ -3339,7 +3339,7 @@
 		   stop if now if appropriate */
 		if (ast_bridged_channel(p->subs[SUB_THREEWAY].owner))
 			ast_moh_stop(ast_bridged_channel(p->subs[SUB_THREEWAY].owner));
-		if (p->subs[SUB_REAL].owner->_state == AST_STATE_RINGING) {
+		if (p->subs[SUB_THREEWAY].owner->_state == AST_STATE_RINGING) {
 			ast_indicate(ast_bridged_channel(p->subs[SUB_REAL].owner), AST_CONTROL_RINGING);
 		}
 		if (p->subs[SUB_REAL].owner->cdr) {
@@ -3363,7 +3363,7 @@
 		ast_mutex_unlock(&p->subs[SUB_THREEWAY].owner->lock);
 		unalloc_sub(p, SUB_THREEWAY);
 	} else if (ast_bridged_channel(p->subs[SUB_THREEWAY].owner)) {
-		if (p->subs[SUB_THREEWAY].owner->_state == AST_STATE_RINGING) {
+		if (p->subs[SUB_REAL].owner->_state == AST_STATE_RINGING) {
 			ast_indicate(ast_bridged_channel(p->subs[SUB_THREEWAY].owner), AST_CONTROL_RINGING);
 		}
 		ast_moh_stop(ast_bridged_channel(p->subs[SUB_THREEWAY].owner));
@@ -4853,10 +4853,11 @@
 			}
 #endif
 			res = tone_zone_play_tone(p->subs[index].zfd, ZT_TONE_RINGTONE);
-			if (chan->_state != AST_STATE_UP && chan->_state != AST_STATE_RING) {
-				if ((p->sig != SIG_FXSKS) &&
-					 (p->sig != SIG_FXSLS) &&
-					 (p->sig != SIG_FXSGS))
+			if (chan->_state != AST_STATE_UP) {
+				if ((chan->_state != AST_STATE_RING) || 
+				    ((p->sig != SIG_FXSKS) &&
+				     (p->sig != SIG_FXSLS) &&
+				     (p->sig != SIG_FXSGS)))
 					ast_setstate(chan, AST_STATE_RINGING);
 			}
 			break;
